Description
Hello,

I am currently working on a project to refactor our foreman infrastructur. For that | was setting up a continuous deployment with r10k
and mcollective. Now | am at the point to import the deployed puppet environments into foreman. | found some nice cli command
which do my work (foreman-rake/hammer-cli). But the biggest problem which | found out that it takes ages to import 50 modules for
10 environments (at least for me).

| have already tried many different thinks:

- used a special proxy running on a bare metal machine just for importing classes
- tested current stable

- tested 1.11-rc2

It is always the same behavior, after adding/scanning 2-3 environments on the proxy the foreman-proxy is getting slower and slower
and slower. The first environment takes ~120 seconds to scan, the second takes ~200 seconds and than is getting slower and
slower. The 5th environment already takes ~35 minutes and | can see in the DEBUG output the proxy need 14 seconds for scanning
on file. After adding some more environments the proxy needs up to 30 seconds to scan just ONE puppet file.

My question is: Is this a known behavior? Can | adjust some settings to make this class scanning faster?

regards,
Mike F.

Related issues:
Related to Smart Proxy - Feature #13667: puppet_proxy and puppetca modules lo... Closed 02/11/2016

History

#1 - 03/18/2016 09:21 AM - Dominic Cleal
- Tracker changed from Support to Bug
- Project changed from Foreman to Smart Proxy

- Category changed from Smart Proxy to Puppet

Refiling this as a bug as | think it can be classed as one in the smart proxy, because it continually reinitialises Puppet to parse each file.

There is a bug report and patch against Puppet to prevent the slow down in the first place: https://tickets.puppetlabs.com/browse/PUP-6000,
https://github.com/puppetlabs/puppet/pull/4752.

There's a refactoring of the smart proxy's parsers in #13667 which Dmitri says will also fix this issue, but that's further off.

#2 - 03/18/2016 09:33 AM - Mike Fréhner

Sounds awesome. | will have a look into it and check if this solves my issue.

#3 - 03/18/2016 09:44 AM - Mike Fréhner
https://github.com/puppetlabs/puppet/pull/4752
https://projects.theforeman.org/issues/13667

There's a refactoring of the smart proxy's parsers in #13667 which Dmitri says will also fix this issue, but that's further off.

| confirm this fixes my problems. !IThank you extremly very MUCH!! for giving that hint!

#4 - 03/18/2016 09:48 AM - Dominic Cleal
- Related to Feature #13667: puppet_proxy and puppetca modules load puppet gem in puppet 4.0 and higher environments added

#5 - 05/18/2016 09:48 AM - Dominic Cleal

- Status changed from New to Resolved

#13667's been merged for 1.12, so tentatively going to mark this as closed as it should be fixed by the change as noted above.
